' 2D-Labyrinth als Spiel. Features:
' - dreidimensionale Grafik in Echtzeit, so dass man darin herumspazieren
'   kann
' - Erzeugung durch den PC mittels Zufallsgenerator, Grsse frei whlbar
' - Steuerung wahlweise ber Tastatur oder Analog-Joystick an Gameport
' (c) 1999 by Andreas Meile, CH-8242 Hofen SH
' e-Mail: andreas@hofen.ch  WWW: http://www.hofen.ch/~andreas/

DECLARE SUB TranspPrint (t$, f%)

DIM LstX%(600), LstY%(600), rx%(3), ry%(3), Pfeil$(0 TO 3), h%(3)

DO
  INPUT "Breite n"; n%
LOOP UNTIL n% >= 1 AND n% <= 39
DO
  INPUT "Hhe m"; m%
LOOP UNTIL m% >= 1 AND m% <= 24
DO
  INPUT "Wahrscheinlichkeit, geradeaus weiterfahren"; wf!
LOOP UNTIL wf! >= 0! AND wf! <= 1!
DO
  INPUT "Steuerung mit Tastatur oder Joystick? (J/T)"; s$
LOOP UNTIL LEN(s$) = 1 AND INSTR("JjTt", s$) <> 0

Joyst% = LCASE$(s$) = "j"

DIM StrTab%(0 TO n% + 1, 0 TO m% + 1)
DIM horizW%(1 TO n%, 0 TO m%), vertW%(0 TO n%, 1 TO m%)

FOR i% = 0 TO 3
  READ h%
  Pfeil$(i%) = CHR$(h%)
NEXT i%
DATA 27, 24, 26, 25

' Alle vier Himmelsrichtungen als Vektoren
rx%(0) = 1: ry%(0) = 0
FOR i% = 1 TO 3
  rx%(i%) = -ry%(i% - 1)
  ry%(i%) = rx%(i% - 1)
NEXT i%

FOR i% = 0 TO n% + 1
  StrTab%(i%, 0) = -1
  StrTab%(i%, m% + 1) = -1
NEXT i%
FOR i% = 1 TO m%
  StrTab%(0, i%) = -1
  FOR j% = 1 TO n%
    StrTab%(j%, i%) = 0
  NEXT j%
  StrTab%(n% + 1, i%) = -1
  FOR j% = 0 TO n%
    vertW%(j%, i%) = -1
  NEXT j%
NEXT i%
FOR i% = 0 TO m%
  FOR j% = 1 TO n%
    horizW%(j%, i%) = -1
  NEXT j%
NEXT i%

RANDOMIZE TIMER

' Grundprinzip: Man geht auf eine "Entdeckungsreise" innerhalb der
' "unbekannten" Labyrintflche, wobei man jeweils von einer bekannten
' Parzelle aus zur nebenan noch unbekannten Parzelle einen Gang grbt

' Wichtiges Charakteristikmerkmal des entstehenden Labyrinths: Es enthlt
' keinerlei Schlaufen, Rundgnge und Schlingen, ist zusammenhngend, d.h.
' jede Stelle ist erreichbar (vgl. mit Wurzelballen einer Pflanze!)

' Weiterverfolgungsliste: Enthlt alle bereits entdeckten Parzellen mit
' noch unerforschten Nachbarn.

' Zu Beginn Startfeld definieren
StartX% = CINT(INT(CSNG(n%) * RND)) + 1
StartY% = CINT(INT(CSNG(m%) * RND)) + 1

LstX%(0) = StartX%
LstY%(0) = StartY%
StrTab%(LstX%(0), LstY%(0)) = -1  ' niedrigstes Feld
ri% = CINT(INT(4! * RND))         ' Zufallsrichtung zu Beginn
s% = 1                            ' Liste zu Beginn 1 Element gross

WHILE s%         ' Solange noch Parzellen mit noch abzuforschenden Nachbarn
  IF RND < wf! THEN
    ' vom letzten geradeaus weiterfahren und Richtung beibehalten
    t% = s% - 1
  ELSE
    ' zufllig eine Parzelle aus der Liste heraussuchen und neue Richtung
    t% = CINT(INT(CSNG(s%) * RND))
    ri% = CINT(INT(4! * RND))
  END IF
  x% = LstX%(t%)
  y% = LstY%(t%)
  t1% = 0: f% = -1
  ' Smtliche Richtungen von unentdeckten Nachbarn heraussuchen
  FOR i% = 0 TO 3
    IF StrTab%(x% + rx%(i%), y% + ry%(i%)) = 0 THEN
      h%(t1%) = i%      ' in eine Hilfsliste nehmen
      t1% = t1% + 1
      IF i% = ri% THEN
        f% = 0
      END IF
    END IF
  NEXT i%
  IF t1% THEN  ' Fortsetzungen gefunden: Neuer Ausgang
    IF f% THEN ' gerade aus weiterfahren nicht mglich
      ' => Richtung per Zufall festlegen, wo weitergefahren werden soll
      ri% = h%(CINT(INT(CSNG(t1%) * RND)))
    END IF
    x1% = x% + rx%(ri%)
    y1% = y% + ry%(ri%)
    SELECT CASE ri%
    CASE 0
      vertW%(x%, y%) = 0    ' nach rechts aufgraben
    CASE 1
      horizW%(x%, y%) = 0   ' nach unten aufgraben
    CASE 2
      vertW%(x1%, y%) = 0   ' nach links aufgraben
    CASE ELSE
      horizW%(x%, y1%) = 0  ' nach oben aufgraben
    END SELECT
    StrTab%(x1%, y1%) = -1  ' Feld als entdeckt kennzeichnen
    LstX%(s%) = x1%         ' und in die Liste aufnehmen
    LstY%(s%) = y1%
    s% = s% + 1
    t1% = t1% - 1           ' jetzt eine Richtung weniger
  END IF
  IF t1% = 0 THEN ' Kein unentdeckter Nachbar mehr => lschen
    s% = s% - 1
    LstX%(t%) = LstX%(s%)   ' letztes Element in die Lcke nehmen
    LstY%(t%) = LstY%(s%)
  END IF
WEND

' Lngste Verbindung zwischen zwei Randfelder suchen = Aufgabe
lm% = -1
FOR i% = 1 TO n%
  ' Flooding-Distanzmessung ausfhren
  LstX%(0) = i%
  LstY%(0) = m%
  StrTab%(LstX%(0), LstY%(0)) = 0  ' Zielfeld
  s% = 1
  WHILE s%
    s% = s% - 1
    x% = LstX%(s%)
    y% = LstY%(s%)
    IF NOT vertW%(x%, y%) AND StrTab%(x% + 1, y%) = -1 THEN
      StrTab%(x% + 1, y%) = StrTab%(x%, y%) + 1
      LstX%(s%) = x% + 1
      LstY%(s%) = y%
      s% = s% + 1
    END IF
    IF NOT horizW%(x%, y%) AND StrTab%(x%, y% + 1) = -1 THEN
      StrTab%(x%, y% + 1) = StrTab%(x%, y%) + 1
      LstX%(s%) = x%
      LstY%(s%) = y% + 1
      s% = s% + 1
    END IF
    IF NOT vertW%(x% - 1, y%) AND StrTab%(x% - 1, y%) = -1 THEN
      StrTab%(x% - 1, y%) = StrTab%(x%, y%) + 1
      LstX%(s%) = x% - 1
      LstY%(s%) = y%
      s% = s% + 1
    END IF
    IF NOT horizW%(x%, y% - 1) AND StrTab%(x%, y% - 1) = -1 THEN
      StrTab%(x%, y% - 1) = StrTab%(x%, y%) + 1
      LstX%(s%) = x%
      LstY%(s%) = y% - 1
      s% = s% + 1
    END IF
  WEND
  FOR j% = 1 TO n%
    IF StrTab%(j%, 1) > lm% THEN
      lm% = StrTab%(j%, 1)
      t% = 0
    END IF
    IF StrTab%(j%, 1) = lm% THEN
      t% = t% + 1
      IF CSNG(t%) * RND < 1! THEN
        Ausg% = i%
        Eing% = j%
      END IF
    END IF
    FOR k% = 1 TO m%
      StrTab%(j%, k%) = -1
    NEXT k%
  NEXT j%
NEXT i%

' Pfeile erzeugen
LstX%(0) = Ausg%
LstY%(0) = m%
StrTab%(LstX%(0), LstY%(0)) = 3
s% = 1
WHILE s%
  s% = s% - 1
  x% = LstX%(s%)
  y% = LstY%(s%)
  IF NOT vertW%(x%, y%) AND StrTab%(x% + 1, y%) = -1 THEN
    StrTab%(x% + 1, y%) = 0
    LstX%(s%) = x% + 1
    LstY%(s%) = y%
    s% = s% + 1
  END IF
  IF NOT horizW%(x%, y%) AND StrTab%(x%, y% + 1) = -1 THEN
    StrTab%(x%, y% + 1) = 1
    LstX%(s%) = x%
    LstY%(s%) = y% + 1
    s% = s% + 1
  END IF
  IF NOT vertW%(x% - 1, y%) AND StrTab%(x% - 1, y%) = -1 THEN
    StrTab%(x% - 1, y%) = 2
    LstX%(s%) = x% - 1
    LstY%(s%) = y%
    s% = s% + 1
  END IF
  IF NOT horizW%(x%, y% - 1) AND StrTab%(x%, y% - 1) = -1 THEN
    StrTab%(x%, y% - 1) = 3
    LstX%(s%) = x%
    LstY%(s%) = y% - 1
    s% = s% + 1
  END IF
WEND

horizW%(Eing%, 0) = 0    ' Ein- und
horizW%(Ausg%, m%) = 0   ' Ausgang "aufbohren"

' Darstellen im Textmodus mit Rahmenzeichen (ASCII 179 - 218)

IF n% < 20 AND m% < 13 THEN
  WIDTH 40, 25
ELSE
  WIDTH 80, 50
END IF
CLS
' "Sulen"
FOR y% = 0 TO m%
  FOR x% = 0 TO n%
    LOCATE 2 * y% + 1, 2 * x% + 1
    PRINT MID$("¿Ŵ", 5 + 3 * ((y% = 0) - (y% = m%)) + (x% = 0) - (x% = n%), 1);
  NEXT x%
NEXT y%
' horizontale Tren
FOR y% = 0 TO m%
  FOR x% = 1 TO n%
    IF horizW%(x%, y%) THEN
      LOCATE 2 * y% + 1, 2 * x%
      PRINT "";
    END IF
  NEXT x%
NEXT y%
' vertikale Tren
FOR y% = 1 TO m%
  FOR x% = 0 TO n%
    IF vertW%(x%, y%) THEN
      LOCATE 2 * y%, 2 * x% + 1
      PRINT "";
    END IF
  NEXT x%
NEXT y%
COLOR 14
FOR y% = 1 TO m%
  FOR x% = 1 TO n%
    LOCATE 2 * y%, 2 * x%
    PRINT Pfeil$(StrTab%(x%, y%));
  NEXT x%
NEXT y%

IF Joyst% THEN
  ' Initialisierung: Smtliche Flags lschen
  FOR i% = 1 TO 10
    FOR j% = 0 TO 3
      dummy% = STICK(j%)
    NEXT j%
    FOR j% = 0 TO 7
      dummy% = STRIG(j%)
    NEXT j%
  NEXT i%
END IF

Drinbleib% = -1
WHILE Drinbleib%
  IF INKEY$ <> "" THEN
    Drinbleib% = 0
  END IF
  IF Joyst% THEN
    IF STRIG(0) THEN
      Drinbleib% = 0
    END IF
  END IF
WEND
IF Joyst% THEN   ' Entprellung ntig => warten, bis man loslsst
  WHILE STRIG(1)
  WEND
END IF

' Navigieren innerhalb einer dreidimensionalen Darstellung

' Abmessungen: 1 Einheit = Parzellenraumgrsse
CONST tb! = .11    ' Trrahmenbreitenfaktor
CONST deck! = .26  ' Hhe Auge - Decke/Mauerkante
CONST bod! = .54   ' Hhe Auge - Boden
CONST xGr! = .0092 ' Breite eines Pixelstreifens (Verhltnis)
CONST yGr! = .0111 ' Hhe eines Pixels (Verhltnis zum Augenabstand)
CONST wAb! = .15   ' minimale Entfernung des Spielers zu einer Wand

' Hilfskonstanten
HFa! = (bod! / yGr!) ^ 2!
DFa! = deck! / bod!
tb2! = 1! - tb!

' Tastatur
LSchritt! = .1   ' Schrittlnge pro Tastendruck
WSchritt! = 9!   ' Drehwinkel beim Wenden pro Tastendruck

' Joystick: Maximalwerte bei voller Hebelauslenkung pro Sekunde
CONST MaxRenn! = .9
CONST MaxDreh! = 70!

' Standort des Spielers
px! = CSNG(Eing%) - .5
py! = .5

' Blickrichtung
vx! = 0!
vy! = 1!
w! = 90!
Pi! = 4! * ATN(1!)
Umr! = Pi! / 180!

' Leere Szene vorbereiten
SCREEN 7, , 4, 4
LINE (0, 0)-(319, 79), 9, BF
LINE (0, 80)-(319, 199), 6, BF
bs% = 0

IF Joyst% THEN
  ' Joystick: Kalibrierung ntig
  SCREEN , , 0, 0
  CLS
  PRINT "Bitte Joystick in alle Richtungen ins"
  PRINT "Maximum auslenken, Maximalwerte mit"
  PRINT "Knopf A lschen, fortsetzen mit Knopf B"
  LINE (22, 26)-(214, 186), 7, B
  LINE (118, 26)-(118, 186), 12
  LINE (22, 106)-(214, 106), 12
  LINE (24, 33)-(36, 33), 15
  LINE (30, 28)-(30, 38), 15
  DIM Kr%(45)
  GET (24, 28)-(36, 38), Kr%
  xAlt% = 24
  yAlt% = 28
  jx% = STICK(0)
  jy% = STICK(1)
  jxAlt% = jx%
  jyAlt% = jy%
  jxMin% = jx% - 1
  jxMax% = jx% + 1
  jyMin% = jy% - 1
  jyMax% = jy% + 1
  dummy% = STRIG(4)
  DO
    jx% = STICK(0)
    jy% = STICK(1)
    IF STRIG(1) THEN
      jxAlt% = jx%
      jyAlt% = jy%
      jxMin% = jx% - 1
      jxMax% = jx% + 1
      jyMin% = jy% - 1
      jyMax% = jy% + 1
    END IF
    jx% = jx% + (jxAlt% - jx% + 128 AND -256)
    jy% = jy% + (jyAlt% - jy% + 128 AND -256)
    jxAlt% = jx%
    jyAlt% = jy%
    IF jx% < jxMin% THEN
      jxMin% = jx%
    END IF
    IF jx% > jxMax% THEN
      jxMax% = jx%
    END IF
    IF jy% < jyMin% THEN
      jyMin% = jy%
    END IF
    IF jy% > jyMax% THEN
      jyMax% = jy%
    END IF
    ' So kalibrieren, dass Werte zwischen 0..1
    KalFx! = 2! / CSNG(jxMax% - jxMin%)
    KalZx! = KalFx! * CSNG(jxMax% + jxMin%) / 2!
    KalFy! = 2! / CSNG(jyMax% - jyMin%)
    KalZy! = KalFy! * CSNG(jyMax% + jyMin%) / 2!
    jx1! = CSNG(jx%) * KalFx! - KalZx!
    jy1! = CSNG(jy%) * KalFy! - KalZy!
    x% = 112 + CINT(96! * jx1!)
    y% = 101 + CINT(80! * jy1!)
    IF x% <> xAlt% OR y% <> yAlt% THEN
      PUT (xAlt%, yAlt%), Kr%, XOR
      PUT (x%, y%), Kr%, XOR
      xAlt% = x%
      yAlt% = y%
    END IF
  LOOP UNTIL STRIG(4)
  ERASE Kr%
  WHILE STRIG(5)
    jx% = STICK(0)
    jy% = STICK(1)
    jx% = jx% + (jxAlt% - jx% + 128 AND -256)
    jy% = jy% + (jyAlt% - jy% + 128 AND -256)
    jxAlt% = jx%
    jyAlt% = jy%
  WEND

  ' Zeitgltter initialisieren (ebenfalls nur Joystick)
  tk! = TIMER + 500! ' Zeitverschiebungskonstante, damit mglichst
  ' nahe bei 0 gerechnet wird (Rundungsfehler!)

  ' Ti! : Zeitgltter, um den groben Takt von nur 18.2 Clocks/Sek der
  ' Systemuhr auszugltten
  DIM Ti!(3)
  ts! = 0!: sc% = 0
  FOR i% = 0 TO 3
    Ti!(i%) = TIMER - tk!
    ts! = ts! + Ti!(i%)
  NEXT i%
END IF

DO
  bs% = bs% + 1 AND 3
  SCREEN , , bs%, bs% - 1 AND 3
  PCOPY 4, bs%
  px1% = CINT(INT(px!)) + 1
  py1% = CINT(INT(py!)) + 1
  FOR x% = 0 TO 319
    h! = xGr! * (CSNG(x%) - 159.5)
    HFa2! = HFa! * (1! + h! * h!)
    ux! = vx! - h! * vy!
    uy! = vy! + h! * vx!
    px2% = px1%
    py2% = py1%
    IF ux! > 0! THEN
      wx% = px1%
      sx% = 1
      xFa% = 5
      sy1! = uy! / ux!
      wy1! = py! + (CSNG(wx%) - px!) * sy1!
    ELSEIF ux! < 0! THEN
      wx% = px1% - 1
      sx% = -1
      xFa% = 2
      sy1! = -uy! / ux!
      wy1! = py! + (px! - CSNG(wx%)) * sy1!
    ELSE
      wx% = 32767
      sx% = 0
    END IF
    IF uy! > 0! THEN
      wy% = py1%
      sy% = 1
      yFa% = 4
      sx1! = ux! / uy!
      wx1! = px! + (CSNG(wy%) - py!) * sx1!
    ELSEIF uy! < 0! THEN
      wy% = py1% - 1
      sy% = -1
      yFa% = 3
      sx1! = -ux! / uy!
      wx1! = px! + (py! - CSNG(wy%)) * sx1!
    ELSE
      wy% = 32767
      sy% = 0
    END IF
    FaBo% = 7 + (px1% + py1% AND 1)
    ' Abstnde
    dx! = CSNG(wx%) - px!: dy! = wy1! - py!
    ax! = dx! * dx! + dy! * dy!
    dx! = wx1! - px!: dy! = CSNG(wy%) - py!
    ay! = dx! * dx! + dy! * dy!
    h% = 200
    Drinbleib% = -1
    WHILE Drinbleib%
      IF ax! < ay! THEN   ' Vertikale Wand
        IF ax! < .0001 THEN
          h1! = 200!
        ELSE
          h1! = SQR(HFa2! / ax!)
        END IF
        t! = CSNG(py2%) - wy1!
        IF t! > tb! AND t! < tb2! THEN
          IF vertW%(wx%, py2%) THEN
            Drinbleib% = 0
            f% = xFa% + 8
          ELSE
            px2% = px2% + sx%
            wx% = wx% + sx%
            IF wx% < 0 OR wx% > n% THEN  ' Sicht in den Ausgang
              f% = 0
              Drinbleib% = 0
            END IF
            wy1! = wy1! + sy1!
            dx! = CSNG(wx%) - px!: dy! = wy1! - py!
            ax! = dx! * dx! + dy! * dy!
          END IF
        ELSE
          Drinbleib% = 0
          f% = xFa%
        END IF
      ELSE      ' Horizontale Wand
        IF ay! < .0001 THEN
          h1! = 200!
        ELSE
          h1! = SQR(HFa2! / ay!)
        END IF
        t! = CSNG(px2%) - wx1!
        IF t! > tb! AND t! < tb2! THEN
          IF horizW%(px2%, wy%) THEN
            Drinbleib% = 0
            f% = yFa% + 8
          ELSE
            py2% = py2% + sy%
            wy% = wy% + sy%
            IF wy% < 0 OR wy% > m% THEN  ' Sicht in den Ausgang
              f% = 0
              Drinbleib% = 0
            END IF
            wx1! = wx1! + sx1!
            dx! = wx1! - px!: dy! = CSNG(wy%) - py!
            ay! = dx! * dx! + dy! * dy!
          END IF
        ELSE
          Drinbleib% = 0
          f% = yFa%
        END IF
      END IF
      ' Vertikale Linie zeichnen
      h2% = 80 + CINT(h1!)
      IF h2% < h% THEN
        LINE (x%, h2%)-(x%, h% - 1), FaBo%
        h% = h2%
      END IF
      FaBo% = 15 - FaBo%
    WEND
    ' Rest
    IF f% THEN
      h2% = 80 - CINT(h1! * DFa!)
      IF h2% < h% THEN
        LINE (x%, h2%)-(x%, h% - 1), f%
      END IF
    END IF
  NEXT x%
  IF Nachr$ <> "" THEN
    LOCATE 2, 21 - LEN(Nachr$) \ 2
    TranspPrint Nachr$, 14
    Nachr$ = ""
  END IF
  SCREEN , , bs%, bs%
  IF Joyst% THEN
    t1! = TIMER - tk!
    dt! = (4! * t1! - ts!) / 10!
    ts! = ts! - Ti!(sc%) + t1!
    Ti!(sc%) = t1!
    sc% = sc% + 1 AND 3
    jx% = STICK(0)
    jy% = STICK(1)
    jx% = jx% + (jxAlt% - jx% + 128 AND -256)
    jy% = jy% + (jyAlt% - jy% + 128 AND -256)
    ' Herausspringen verhindern
    IF jx% > jxMax% + 10 THEN
      jx% = jx% - 256
    END IF
    IF jx% < jxMin% - 10 THEN
      jx% = jx% + 256
    END IF
    IF jy% > jyMax% + 10 THEN
      jy% = jy% - 256
    END IF
    IF jy% < jyMin% - 10 THEN
      jy% = jy% + 256
    END IF
    jxAlt% = jx%
    jyAlt% = jy%
    jx1! = CSNG(jx%) * KalFx! - KalZx!
    jy1! = CSNG(jy%) * KalFy! - KalZy!
    IF STRIG(5) THEN
      MaxR1! = 3! * MaxRenn!   ' 3x schneller
      MaxD1! = 3! * MaxDreh!
    ELSE
      MaxR1! = MaxRenn!
      MaxD1! = MaxDreh!
    END IF
    IF STRIG(1) THEN    ' 1. Feuerknopf: Hin- und Her statt Drehen
      px! = px! - dt! * MaxR1! * (jy1! * vx! + jx1! * vy!)
      py! = py! - dt! * MaxR1! * (jy1! * vy! - jx1! * vx!)
    ELSE
      dw! = dt! * MaxD1! * jx1!
      wRad! = Umr! * (w! + dw! / 2!)   ' Mittelwert verwenden
      vx! = COS(wRad!)
      vy! = SIN(wRad!)
      px! = px! - dt! * MaxR1! * jy1! * vx!
      py! = py! - dt! * MaxR1! * jy1! * vy!
      w! = w! + dw!
    END IF
    t$ = INKEY$
  ELSE
    DO
      t$ = INKEY$
    LOOP WHILE t$ = ""
    SELECT CASE t$
    CASE CHR$(0) + "H"
      px! = px! + LSchritt! * vx!
      py! = py! + LSchritt! * vy!
    CASE CHR$(0) + "K"
      w! = w! - WSchritt!
    CASE CHR$(0) + "M"
      w! = w! + WSchritt!
    CASE CHR$(0) + "P"
      px! = px! - LSchritt! * vx!
      py! = py! - LSchritt! * vy!
    CASE CHR$(0) + "s"
      px! = px! + LSchritt! * vy!
      py! = py! - LSchritt! * vx!
    CASE CHR$(0) + "t"
      px! = px! - LSchritt! * vy!
      py! = py! + LSchritt! * vx!
    CASE CHR$(0) + "I"
      LSchritt! = LSchritt! * 1.25
      WSchritt! = 90! * LSchritt!
      IF WSchritt! > 120! THEN
        WSchritt! = 120!
      END IF
    CASE CHR$(0) + "Q"
      LSchritt! = LSchritt! / 1.25
      WSchritt! = 90! * LSchritt!
    CASE "E", "e"  ' Einheitsschritt
      LSchritt! = 1!
      WSchritt! = 90!
      px! = INT(px!) + .5
      py! = INT(py!) + .5
      w! = 90! * INT(w! / 90! + .5)
    CASE "O", "o"  ' Orthogonalisieren
      px! = INT(px!) + .5
      py! = INT(py!) + .5
      w! = 90! * INT(w! / 90! + .5)
    END SELECT
    w! = w! - 360! * INT(w! / 360!)
    wRad! = w! * Umr!
    vx! = COS(wRad!)
    vy! = SIN(wRad!)
  END IF

  ' Limiten prfen, damit man nicht durch eine Wand gehen kann!
  tx! = CSNG(px1%) - px!
  ty! = CSNG(py1%) - py!
  IF tx! < wAb! THEN
    IF vertW%(px1%, py1%) THEN
      px! = CSNG(px1%) - wAb!  ' Wand
    ELSE
      IF ty! < tb! + wAb! THEN
        IF tx! > ty! - tb! THEN
          px! = CSNG(px1%) - wAb!
        ELSE
          py! = CSNG(py1%) - tb! - wAb!
        END IF
      ELSEIF ty! > tb2! - wAb! THEN
        IF tx! > tb2! - ty! THEN
          px! = CSNG(px1%) - wAb!
        ELSE
          py! = CSNG(py1%) - tb2! + wAb!
        END IF
      END IF
    END IF
  ELSEIF tx! > 1! - wAb! THEN
    IF vertW%(px1% - 1, py1%) THEN
      px! = CSNG(px1% - 1) + wAb! ' Wand
    ELSE
      IF ty! < tb! + wAb! THEN
        IF 1! - tx! > ty! - tb! THEN
          px! = CSNG(px1% - 1) + wAb!
        ELSE
          py! = CSNG(py1%) - tb! - wAb!
        END IF
      ELSEIF ty! > tb2! - wAb! THEN
        IF 1! - tx! > tb2! - ty! THEN
          px! = CSNG(px1% - 1) + wAb!
        ELSE
          py! = CSNG(py1%) - tb2! + wAb!
        END IF
      END IF
    END IF
  END IF
  IF ty! < wAb! THEN
    IF horizW%(px1%, py1%) THEN
      py! = CSNG(py1%) - wAb!  ' Wand
    ELSE
      IF tx! < tb! + wAb! THEN
        IF ty! > tx! - tb! THEN
          py! = CSNG(py1%) - wAb!
        ELSE
          px! = CSNG(px1%) - tb! - wAb!
        END IF
      ELSEIF tx! > tb2! - wAb! THEN
        IF ty! > tb2! - tx! THEN
          py! = CSNG(py1%) - wAb!
        ELSE
          px! = CSNG(px1%) - tb2! + wAb!
        END IF
      END IF
    END IF
  ELSEIF ty! > 1! - wAb! THEN
    IF horizW%(px1%, py1% - 1) THEN
      py! = CSNG(py1% - 1) + wAb! ' Wand
    ELSE
      IF tx! < tb! + wAb! THEN
        IF 1! - ty! > tx! - tb! THEN
          py! = CSNG(py1% - 1) + wAb!
        ELSE
          px! = CSNG(px1%) - tb! - wAb!
        END IF
      ELSEIF tx! > tb2! - wAb! THEN
        IF 1! - ty! > tb2! - tx! THEN
          py! = CSNG(py1% - 1) + wAb!
        ELSE
          px! = CSNG(px1%) - tb2! + wAb!
        END IF
      END IF
    END IF
  END IF
  IF py! <= 0! THEN   ' Zu Start zurckgekehrt
    Nachr$ = "Eingang! Von hier kommen Sie her!"
    py! = .01
  END IF
LOOP UNTIL t$ = CHR$(27) OR py! >= CSNG(m%)

SCREEN 0
WIDTH 80, 25

IF py! > CSNG(m%) THEN
  PRINT "Gratuliere! :-) Sie haben den Ausgang gefunden"
END IF

SUB TranspPrint (t$, f%)
  x% = POS(0)
  y% = CSRLIN
  DIM h1%(16 * LEN(t$) + 1)
  x1% = 8 * x% - 8
  y1% = 8 * y% - 8
  x2% = x1% + 8 * LEN(t$) - 1
  y2% = y1% + 7
  GET (x1%, y1%)-(x2%, y2%), h1%
  COLOR 15
  PRINT t$;
  PUT (x1%, y1%), h1%, OR
  GET (x1%, y1%)-(x2%, y2%), h1%
  COLOR 15 - f%
  LOCATE y%, x%
  PRINT t$;
  PUT (x1%, y1%), h1%, XOR
  ERASE h1%
  LOCATE y%, x%
END SUB

